-- ~*~*~*~*~*~*子弹发射器(使用RayTest)*~*~*~*~*~*~*~*~


function shot()

    local screen_pos = app:get_screen_size() * ae.ARVec2:new_local(0.5, 0.5)

    local ray_caster = scene:get_input_controller():get_ray_caster()
    local ray = ray_caster:ray_from_screen(screen_pos)

    local hit_result = ray_caster:get_hit_result(ray, "first_hit")
    local result = hit_result["result"]
    if (result[0] ~= nil) then
        local node = result[0]["node"]
        local distance = result[0]["distance"]
         if (node ~= nil) then

            local hit_pos = ray:origin() + ray:direction() * distance
            local name = node:get_property_string("name")
            do_damage_to_monsters(name, hit_pos)
        end
    end

    play_fire_gun_music()
end


function do_damage_to_monsters(monster_name, pos)
    for k,v in pairs(monster_list) do
        if (v.is_alive) then
            if (v.name == monster_name) then
                v:receive_damage(100)
                create_monster_hit_bleeding(pos)
            end
        end
    end
end

