function show_initial_view()
    app:visible_type(ViewVisibleType.HideAllButton)
    scene.exit:set_visible(true)
    scene.progressBar:set_visible(true)
	scene.on_loading_text:set_visible(true)
    scene.loading_bg:set_visible(true)
end

function show_detect_view()
    scene.progressBar:set_visible(false)
    scene.on_loading_text:set_visible(false)
    scene.loading_bg:set_visible(false)
    scene.start_game:set_property_bool("visible",false)
    scene.start_detect:set_property_bool("visible",false)
    scene.shoot_right:set_property_bool("visible",false)
    scene.shoot_left:set_property_bool("visible",false)
    scene.score_board:set_property_bool("visible", false)
    scene.horizontal:set_visible(true)
    scene.vertical:set_visible(true)
end

function show_detected_view()
    scene.horizontal:set_visible(false)
    scene.vertical:set_visible(false)

    scene.progressBar:set_visible(false)
	scene.on_loading_text:set_visible(false)
    scene.loading_bg:set_visible(false)
    scene.introduce:set_visible(false)
    scene.start_game:set_property_bool("visible",false)
    scene.start_detect:set_property_bool("visible",false)
    scene.shoot_right:set_property_bool("visible",false)
    scene.shoot_left:set_property_bool("visible",false)
    scene.score_board:set_property_bool("visible", false)
end

function show_begin_view()
    scene.start_game:set_property_bool("visible",true)
    scene.progressBar:set_visible(false)
	scene.on_loading_text:set_visible(false)
    scene.introduce:set_visible(true)
    scene.start_detect:set_property_bool("visible",false)
    scene.shoot_right:set_property_bool("visible",false)
    scene.shoot_left:set_property_bool("visible",false)
    scene.score_board:set_property_bool("visible", false)
    scene.find_vertical:set_visible(false)
    scene.find_horizontal:set_visible(false)
end

function show_play_view()
    scene.progressBar:set_visible(false)
	scene.on_loading_text:set_visible(false)
    scene.target:set_property_bool("visible",true)
    scene.start_game:set_property_bool("visible",false)
    scene.introduce:set_property_bool("visible",false)
    scene.shoot_right:set_property_bool("visible",true)
    scene.shoot_left:set_property_bool("visible",true)
    scene.score_board:set_property_bool("visible", true)
    scene.radar:set_property_bool("visible", true)
end

function show_over_view()
    scene.progressBar:set_visible(false)
	scene.on_loading_text:set_visible(false)
    scene.target:set_property_bool("visible",true)
    scene.start_game:set_property_bool("visible",false)
    scene.shoot_right:set_property_bool("visible",false)
    scene.shoot_left:set_property_bool("visible",false)
    scene.score_board:set_property_bool("visible", false)
end

function show_find_vertical()
    scene.find_vertical:set_visible(true)
    scene.vertical:set_visible(false)

	scene.on_loading_text:set_visible(false)
    scene.target:set_property_bool("visible",false)
    scene.start_game:set_property_bool("visible",false)
    scene.shoot_right:set_property_bool("visible",false)
    scene.shoot_left:set_property_bool("visible",false)
    scene.score_board:set_property_bool("visible", false)
end

function show_find_horizontal()
    scene.find_horizontal:set_visible(true)
    scene.horizontal:set_visible(false)

	scene.on_loading_text:set_visible(false)
    scene.target:set_property_bool("visible",false)
    scene.start_game:set_property_bool("visible",false)
    scene.shoot_right:set_property_bool("visible",false)
    scene.shoot_left:set_property_bool("visible",false)
    scene.score_board:set_property_bool("visible", false)
end
